#!/bin/sh

function tobi_sources()
{
    mv /etc/apt/sources.list /etc/apt/sources.list.save
    cat > /etc/apt//sources.list <<EOT
# See sources.list(5) for more information, especialy
# Remember that you can only use http, ftp or file URIs
# CDROMs are managed through the apt-cdrom tool.

# Unstable
deb http://ftp.de.debian.org/debian unstable main contrib non-free
deb-src http://ftp.de.debian.org/debian unstable main contrib non-free

# Testing
deb http://ftp.de.debian.org/debian testing main contrib non-free
deb-src http://ftp.de.debian.org/debian testing main contrib non-free

# Experimental
#deb http://ftp.de.debian.org/debian experimental main contrib non-free
#deb-src http://ftp.de.debian.org/debian experimental main contrib non-free

# Kanotix
deb http://kanotix.com/files/debian sid main contrib non-free vdr
deb-src http://kanotix.com/files/debian sid main contrib non-free vdr

# Tobi's Experimental VDR Repository (multipatch)
deb http://e-tobi.net/vdr-experimental sid base addons vdr-multipatch
deb-src http://e-tobi.net/vdr-experimental sid base addons vdr-multipatch
EOT
}

function save_config()
{
    cp /var/lib/vdr/channels.conf /tmp/channels.conf.BeforeUpdate
    cp /var/lib/vdr/remote.conf /tmp/remote.conf.BeforeUpdate
}

function restore_config()
{
   mv -f /tmp/remote.conf.BeforeUpdate /var/lib/vdr/remote.conf
   mv -f /tmp/channels.conf.BeforeUpdate /var/lib/vdr/channels.conf
}

function tobi_pref()
{
    mv /etc/apt/preferences /etc/apt/preferences.save
    cat > /etc/apt/preferences <<EOT
Package: * 
Pin: release o=e-tobi.net 
Pin-Priority: 1001

Package: *
Pin: release a=unstable
Pin-Priority: 500

Package: *
Pin: release a=testing
Pin-Priority: 200

Package: *
Pin: release a=experimental
Pin-Priority: 50
EOT
}

function multimedia_rep()
{
    rep=`grep debian-multimedia /etc/apt/sources.list`
    if [ "$rep" = ""  ] ; then 
       echo "" >> /etc/apt/sources.list
       echo "# debian multimedia" >> /etc/apt/sources.list
       echo "deb http://www.debian-multimedia.org sid main"  >> /etc/apt/sources.list
       echo "deb-src http://www.debian-multimedia.org sid main"  >> /etc/apt/sources.list

       gpg --keyserver wwwkeys.eu.pgp.net --recv-keys 1F41B907 && apt-key add /root/.gnupg/pubring.gpg
    fi
}

# Start
if [ $(id -u) != 0 ] ; then 
	echo "Only root can run this script! "
	exit 1
fi

echo
echo
echo "====================================================="
echo
echo "this script delete's vdr and install a newer VDR"
echo "with xineliboutput instead of xine-plugin"
echo "-----------------------------------------------------"
echo
echo "maybe you should save this files/dir's bevor"
echo "-----------------------------------------------------"
echo "/etc/default/vdr"
echo "/etc/default/vdradmin-am"

echo "/usr/share/vdr"
echo "/etc/vdr"
echo "/var/lib/vdr"
echo "/usr/lib/vdr"
echo
echo "if you want install the new VDR type <y>"
read answer

if [ "$answer" = "y" ]; then

save_config
tobi_sources
tobi_pref

echo "install debian-multimedia Repository, needs some plugins? (y/n)" && read multimedia
[ "$multimedia" = "y" ] && multimedia_rep

apt-get update

/etc/init.d/vdr stop
COLUMNS=200 dpkg -l|awk '/vdr/{print $2}'|grep -v -e dvdrtools -e libdvdread3|xargs -r apt-get remove --purge --yes --force-yes
rm -rf /var/lib/vdr /etc/vdr /etc/default/vdr*

apt-get install --allow-unauthenticated --yes libxine1/unstable libxine-dev/unstable kanotix-vdr vdr-skins
perl -pi -e 's%(ENABLED=).*%${1}1%' /etc/default/vdr /etc/default/vdradmin-am
restore_config
/etc/init.d/vdr restart
/etc/init.d/vdradmin-am restart

fi

echo
echo
echo "==============================================================="
echo "original sources.list was saved to /etc/apt/preferences.save"
echo "prefernces to /etc/apt/preferences.save"
echo
echo "see a list of all plugins:    apt-get update && clear && apt-cache search ^vdr- | more"
echo "install it with:              apt-get update && apt-get install <package>"
echo
